hosts = {
    "controlnode" => {
        "ip" => "10.10.10.10",
        "memory" => 1024
    },
    "target01" => {
        "ip" => "10.10.10.20",
        "memory" => 1024
    },
    "target02" => {
        "ip" => "10.10.10.21",
        "memory" => 1024
    },
}


Vagrant.configure("2") do |config|
    hosts.each do |name, settings|
        config.vm.define name do |machine|
            machine.vm.box = "ubuntu/bionic64"
            machine.vm.hostname = name
            machine.vm.network "private_network", ip: settings["ip"]

            machine.vm.provider "virtualbox" do |vb|
                vb.name = name
                vb.memory = settings["memory"]
            end
            machine.vm.provision "file", source: "~/.ssh/id_rsa.pub", destination: "~/.ssh/me.pub"
            machine.vm.provision "shell", inline: <<-SHELL
                cat /home/vagrant/.ssh/me.pub >> /home/vagrant/.ssh/authorized_keys
            SHELL
        end
    end
end